﻿using Microsoft.VisualBasic;
using Microsoft.VisualBasic.CompilerServices;

using Proto;

namespace TestProject;

/// <summary>
/// 이벤트 스트림 확장
/// </summary>
public static class EventStreamExtension
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region 주제에 구독하기 - SubscribeToTopic<T>(eventStream, topic, action)

    /// <summary>
    /// 주제에 구독하기
    /// </summary>
    /// <typeparam name="T">주제 메시지 인터페이스</typeparam>
    /// <param name="eventStream">이벤트 스트림</param>
    /// <param name="topic">주제</param>
    /// <param name="action">액션</param>
    /// <returns>이벤트 스트림 구독</returns>
    public static EventStreamSubscription<object> SubscribeToTopic<T>(this EventStream eventStream, string topic, Action<T> action) where T : ITopicMessage
    {
        return eventStream.Subscribe<T>
        (
            x =>
            {
                if(!LikeOperator.LikeString(x.Topic, topic, CompareMethod.Binary))
                {
                    return;
                }

                action(x);
            }
        );
    }

    #endregion
}